<?php
/*
Plugin Name: Xoogu Dynamic Shortcodes for W3TC
Description: Allows use of partial caching while keeping certain shortcodes dynamic
Version: 2017-01-01
Plugin URI: http://www.xoogu.com/dynamic-shortcodes-extension-for-w3-total-cache/
Author: Xoogu.com
Author URI: http://www.xoogu.com/
Network: True
*/

if ( !defined( 'ABSPATH' ) ) {
	die('No Abspath');
}

add_filter( 'w3tc_extensions', 'xoogu_dynamic_shortcodes_w3tc_register_extension', 10, 2 );

    

/**
 * Register the extension with W3TC
 * @param array $aExtensions Array of extensions installed
 * @param W3_Config $oConfig
 * @return array Array of extensions installed
 */
function xoogu_dynamic_shortcodes_w3tc_register_extension($aExtensions, $oConfig)
{
    $aExtensions['xoogu-dynamic-shortcodes-w3tc'] = array (
        'name' => __('Dynamic Shortcodes', 'xoogu-dynamic-shortcodes-w3tc'),
        'author' => 'xoogu.com',
        'description' => __('Allows selected shortcodes to be generated dynamically on every page load.', 'xoogu-dynamic-shortcodes-w3tc'),
        'author uri' => 'http://www.xoogu.com/',
        'extension uri' => 'http://www.xoogu.com/dynamic-shortcodes-extension-for-w3-total-cache/',
        'extension id' => 'xoogu-dynamic-shortcodes-w3tc',
        'version' => '2017-01-01',
		'settings_exists' => true,
        'enabled' => $oConfig->get_boolean('pgcache.late_init'),
        'requirements' => sprintf(__('Late init must be enabled (see %s)', 'xoogu-dynamic-shortcodes-w3tc'), sprintf('<a href="'.strtok($_SERVER["REQUEST_URI"],'?').'?page=w3tc_pgcache#advanced">%s</a>', __('W3TC Page Cache settings', 'xoogu-dynamic-shortcodes-w3tc'))),
        //in theory should be able to define W3TC_EXTENSION_DIR to change extensions dir, defaults to wp-content/plugins
        //however, W3TC globs W3TC_DIR . '/extensions/' to find the extensions, so impossible to locate extensions in different dir to default
        'path' => plugin_basename(dirname(__FILE__).'/run-extension.php')
    );

    return $aExtensions;
}
